#!/bin/bash
CXX=arm-linux-gnueabihf-g++
CXXFLAGS="-nostdlib -march=armv7-a -mtune=cortex-a9 -mfloat-abi=softfp -mfpu=vfpv3-d16 -fPIC -ffunction-sections -Wno-psabi -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -Isources -Iheaders -Wa,--noexecstack -DYEP_BUILD_LIBRARY -c"
AS=arm-linux-gnueabihf-as
ASFLAGS="-Isources/arm --noexecstack"
RM=rm
RMFLAGS="-rf"

$RM $RMFLAGS "binaries/arm-linux-hardeabi-v7a" > /dev/null
mkdir "binaries/arm-linux-hardeabi-v7a/"
mkdir "binaries/arm-linux-hardeabi-v7a/library/"
mkdir "binaries/arm-linux-hardeabi-v7a/core/"
mkdir "binaries/arm-linux-hardeabi-v7a/math/"

$CXX -Os -mthumb $CXXFLAGS sources/core/Add.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/Add.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/Add.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/Add.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Subtract.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/Subtract.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/Subtract.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/Subtract.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Multiply.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/Multiply.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/Multiply.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/Multiply.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/MultiplyAdd.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/MultiplyAdd.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/MultiplyAdd.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/MultiplyAdd.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/Negate.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/Negate.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/Negate.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/Negate.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/DotProduct.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/DotProduct.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/DotProduct.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/DotProduct.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/core/SumSquares.disp.cpp -o binaries/arm-linux-hardeabi-v7a/core/SumSquares.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/core/SumSquares.impl.cpp -o binaries/arm-linux-hardeabi-v7a/core/SumSquares.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/math/Log.disp.cpp -o binaries/arm-linux-hardeabi-v7a/math/Log.disp.o

$CXX -O3 -mthumb $CXXFLAGS sources/math/Log.impl.cpp -o binaries/arm-linux-hardeabi-v7a/math/Log.impl.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Init.cpp -o binaries/arm-linux-hardeabi-v7a/library/Init.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Cpu.cpp -o binaries/arm-linux-hardeabi-v7a/library/Cpu.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Timer.cpp -o binaries/arm-linux-hardeabi-v7a/library/Timer.o

$CXX -Os -mthumb $CXXFLAGS sources/library/Strings.cpp -o binaries/arm-linux-hardeabi-v7a/library/Strings.o

$AS $ASFLAGS sources/library/Probe.arm.asm -o binaries/arm-linux-hardeabi-v7a/library/Probe.arm.o

$CXX -nostdlib -Wl,-soname,libyeppp.so -shared -Wl,--version-script=sources/libyeppp.so.map binaries/arm-linux-hardeabi-v7a/core/Add.disp.o binaries/arm-linux-hardeabi-v7a/core/Add.impl.o binaries/arm-linux-hardeabi-v7a/core/Subtract.disp.o binaries/arm-linux-hardeabi-v7a/core/Subtract.impl.o binaries/arm-linux-hardeabi-v7a/core/Multiply.disp.o binaries/arm-linux-hardeabi-v7a/core/Multiply.impl.o binaries/arm-linux-hardeabi-v7a/core/MultiplyAdd.disp.o binaries/arm-linux-hardeabi-v7a/core/MultiplyAdd.impl.o binaries/arm-linux-hardeabi-v7a/core/Negate.disp.o binaries/arm-linux-hardeabi-v7a/core/Negate.impl.o binaries/arm-linux-hardeabi-v7a/core/DotProduct.disp.o binaries/arm-linux-hardeabi-v7a/core/DotProduct.impl.o binaries/arm-linux-hardeabi-v7a/core/SumSquares.disp.o binaries/arm-linux-hardeabi-v7a/core/SumSquares.impl.o binaries/arm-linux-hardeabi-v7a/math/Log.disp.o binaries/arm-linux-hardeabi-v7a/math/Log.impl.o binaries/arm-linux-hardeabi-v7a/library/Cpu.o binaries/arm-linux-hardeabi-v7a/library/Timer.o binaries/arm-linux-hardeabi-v7a/library/Init.o binaries/arm-linux-hardeabi-v7a/library/Strings.o binaries/arm-linux-hardeabi-v7a/library/Probe.arm.o -Wl,--no-undefined -Wl,-z,noexecstack -L../runtime/binaries/arm-linux-hardeabi-v7a -o binaries/arm-linux-hardeabi-v7a/libyeppp.so -lyeprt

arm-linux-gnueabihf-strip binaries/arm-linux-hardeabi-v7a/libyeppp.so
arm-linux-gnueabihf-strip -R .comment -R .note.gnu.build-id binaries/arm-linux-hardeabi-v7a/libyeppp.so
